<?php

class WikiVOAuth {

    function authorize($attributes) {

        global $vo_attribute_name;
        $simplesaml_UN = $attributes['hrEduPersonUniqueID'][0];
        $wikivomember = $attributes[$vo_attribute_name . ":voMember"][0];
        $wikivowriter = $attributes[$vo_attribute_name . ":voWriter"][0];

        if ($wikivomember) {

            $tmpstring = ucfirst($simplesaml_UN);
            $dbr = wfGetDB(DB_SLAVE);
            $res = $dbr->select('user', array('user_name', 'user_id'), array('user_name' => $tmpstring));
            $row = $dbr->fetchObject($res);

            if (($row->user_name) == $tmpstring) {
                //korisnik postoji u bazi
                if ($wikivowriter) {

                    $res2 = $dbr->select('user_groups', array('ug_user', 'ug_group'), array('ug_user' => $row->user_id));
                    $pisac = false;
                    while ($row2 = $dbr->fetchObject($res2)) {

                        if ($row2->ug_group == 'writer') {
                            $pisac = true;
                        }
                    }
                    if (!$pisac) {
                        $dbw = wfGetDB(DB_MASTER);
                        $dbw->begin();
                        $dbw->insert('user_groups', array('ug_user' => $row->user_id, 'ug_group' => 'writer'));
                        $dbw->commit();
                    }
                } else {
                    //nema atribut writer
                    $res3 = $dbr->select('user_groups', array('ug_user', 'ug_group'), array('ug_user' => $row->user_id));
                    $pisac3 = false;
                    while ($row3 = $dbr->fetchObject($res3)) {

                        if ($row3->ug_group == 'writer') {
                            $pisac = true;
                        }
                    }
                    if ($pisac) {
                        $dbw = wfGetDB(DB_MASTER);
                        $dbw->begin();
                        $dbw->delete('user_groups', array('ug_user' => $row->user_id, 'ug_group' => 'writer'));
                        $dbw->commit();


                        //sad jos provjeriti je li citac pa ga dodati ako vec nije u bazi
                        $res3 = $dbr->select('user_groups', array('ug_user', 'ug_group'), array('ug_user' => $row->user_id));
                        $citac = false;
                        while ($row2 = $dbr->fetchObject($res2)) {

                            if ($row2->ug_group == 'reader') {
                                $citac = true;
                            }
                        }
                        if (!$citac) {
                            $dbw2 = wfGetDB(DB_MASTER);
                            $dbw2->begin();
                            $dbw2->insert('user_groups', array('ug_user' => $row->user_id, 'ug_group' => 'reader'));
                            $dbw2->commit();
                        }
                    }
                }
            } else {
                //echo "NEEEnpostoji";
                //treba ga dodati ili kao writera ili kao readera
                $osnovnepostavke = "quickbar=1
							underline=2
							cols=80
							rows=25
							searchlimit=20
							contextlines=5
							contextchars=50
							disablesuggest=0
							skin=
							math=1
							usenewrc=0
							rcdays=7
							rclimit=50
							wllimit=250
							hideminor=0
							hidepatrolled=0
							newpageshidepatrolled=0
							highlightbroken=1
							stubthreshold=0
							previewontop=1
							previewonfirst=0
							editsection=1
							editsectiononrightclick=0
							editondblclick=0
							editwidth=0
							showtoc=1
							showtoolbar=1
							minordefault=0
							date=default
							imagesize=2
							thumbsize=2
							rememberpassword=0
							nocache=0
							diffonly=0
							showhiddencats=0
							norollbackdiff=0
							enotifwatchlistpages=0
							enotifusertalkpages=1
							enotifminoredits=0
							enotifrevealaddr=0
							shownumberswatching=1
							fancysig=0
							externaleditor=0
							externaldiff=0
							forceeditsummary=0
							showjumplinks=1
							justify=0
							numberheadings=0
							uselivepreview=0
							watchlistdays=3
							extendwatchlist=0
							watchlisthideminor=0
							watchlisthidebots=0
							watchlisthideown=0
							watchlisthideanons=0
							watchlisthideliu=0
							watchlisthidepatrolled=0
							watchcreations=0
							watchdefault=0
							watchmoves=0
							watchdeletion=0
							noconvertlink=0
							gender=unknown
							variant=en
							language=hr
							searchNs0=1";

                $dbw = wfGetDB(DB_MASTER);
                $dbw->begin();
                $dbw->insert('user', array('user_name' => $tmpstring, 'user_options' => $osnovnepostavke));
                $dbw->commit();


                if ($wikivowriter) {

                    $dbr4 = wfGetDB(DB_SLAVE);
                    $res4 = $dbr4->select('user', array('user_name', 'user_id'), array('user_name' => $tmpstring));
                    $row4 = $dbr4->fetchObject($res4);

                    $dbw2 = wfGetDB(DB_MASTER);
                    $dbw2->begin();
                    $dbw2->insert('user_groups', array('ug_user' => $row4->user_id, 'ug_group' => 'writer'));
                    $dbw2->commit();
                } else {

                    $dbr4 = wfGetDB(DB_SLAVE);
                    $res4 = $dbr4->select('user', array('user_name', 'user_id'), array('user_name' => $tmpstring));
                    $row4 = $dbr4->fetchObject($res4);

                    $dbw2 = wfGetDB(DB_MASTER);
                    $dbw2->begin();
                    $dbw2->insert('user_groups', array('ug_user' => $row4->user_id, 'ug_group' => 'reader'));
                    $dbw2->commit();
                }
            }
        } else {
            die("Nemate pravo pristupa!");
        }
    }

}

$config = SimpleSAML_Configuration::getInstance();
$simpleSAMLsession = SimpleSAML_Session::getInstance();

if (!$simpleSAMLsession->isValid('saml2')) {
    SimpleSAML_Utilities::redirect(
            '/' . $config->getBaseURL() . 'saml2/sp/initSSO.php', array('RelayState' => SimpleSAML_Utilities::selfURL())
    );
}


$attributesSAML = $simpleSAMLsession->getAttributes();

function vo_hook() {
    global $attributesSAML;
    $wikivo = new WikiVOAuth();
    $wikivo->authorize($attributesSAML);

    if (!isset($_SESSION['reload_vars'])) {
        $_SESSION['reload_vars'] = "yes";
        header('Location: ' . $_SERVER['PHP_SELF']);
    }
}

$wgExtensionFunctions[] = "vo_hook";


$wgExtensionCredits['other']['WikiVOAuth'] = array(
    'name' => 'WikiVOAuth',
    'version' => '0.9',
    'author' => 'Miro Macinkovic',
    'url' => 'http://developer.aaiedu.hr/faq.html',
    'description' => 'Wiki - virtualne organizacije'
);
?>
